package com.jiuqi.util.comparator;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Comparator;

public final class StringComparator implements Comparator {
  private boolean isDescOrder;
  
  private boolean ignoreCase;
  
  public StringComparator() {}
  
  public StringComparator(boolean isDescOrder) {
    this.isDescOrder = isDescOrder;
  }
  
  public StringComparator(boolean isDescOrder, boolean ignoreCase) {
    this.isDescOrder = isDescOrder;
    this.ignoreCase = ignoreCase;
  }
  
  public int compare(Object o1, Object o2) {
    if (o1 == o2)
      return 0; 
    int ret = 0;
    if (o1 == null) {
      ret = -1;
    } else if (o2 == null) {
      ret = 1;
    } else {
      ret = this.ignoreCase ? ((String)o1).compareToIgnoreCase((String)o2) : ((String)o1).compareTo((String)o2);
    } 
    return this.isDescOrder ? -ret : ret;
  }
  
  public boolean equals(Object obj) {
    if (this == obj)
      return true; 
    if (this == null || obj == null)
      return false; 
    if (obj instanceof com.jiuqi.util.comparator.StringComparator) {
      com.jiuqi.util.comparator.StringComparator cmp = (com.jiuqi.util.comparator.StringComparator)obj;
      return (cmp.ignoreCase == this.ignoreCase && cmp.isDescOrder == this.isDescOrder);
    } 
    return false;
  }
  
  public String toString() {
    return "[字符串比较器, " + (this.isDescOrder ? "降序" : "升序") + (this.ignoreCase ? ", 忽略大小写]" : "]");
  }
  
  public boolean isDescOrder() {
    return this.isDescOrder;
  }
  
  public void setDescOrder(boolean isDescOrder) {
    this.isDescOrder = isDescOrder;
  }
  
  public boolean isIgnoreCase() {
    return this.ignoreCase;
  }
  
  public void setIgnoreCase(boolean ignoreCase) {
    this.ignoreCase = ignoreCase;
  }
}
